<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmClassificacaoParceiroService;

class CrmClassificacaoParceiroController {
    
    protected $CrmClassificacaoParceiroService;

    use TResponse;

    public function __construct(CrmClassificacaoParceiroService $CrmClassificacaoParceiroService)
    {
        $this->CrmClassificacaoParceiroService = $CrmClassificacaoParceiroService;
    }

    public function getRankingPartner (){
        try {
            $data = $this->CrmClassificacaoParceiroService->getRankingPartnerService();
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
    
    public function saveNewRankingPartner (Request $request) {
        try {

            $data = $this->CrmClassificacaoParceiroService->saveNewRankingPartnerService($request->getParameters());
            
        } catch (\Exception $e) {

            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function deleteRankingPartner (Request $request){
        try {
            $data = $this->CrmClassificacaoParceiroService->deleteRankingPartnerService($request->getParameters());
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}