<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmConcorrenteService;
use Zeedhi\Framework\DTO\Response;

class CrmConcorrenteController
{

    protected $CrmConcorrenteService;

    use TResponse;

    public function __construct(CrmConcorrenteService $CrmConcorrenteService)
    {
        $this->CrmConcorrenteService = $CrmConcorrenteService;
    }

    public function getCompetition()
    {
        try {
            $data = $this->CrmConcorrenteService->getCompetitionService();
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function saveNewCompetition(Request $request)
    {
        try {
            $data = $this->CrmConcorrenteService->saveNewCompetitionService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function updateCompetition(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->CrmConcorrenteService->updateCompetitionService($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function deleteCompetition(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->CrmConcorrenteService->deleteCompetitionService($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}
