<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmTipoRevendaService;
use Zeedhi\Framework\DTO\Response;

class CrmTipoRevendaController
{

    protected $CrmTipoRevendaService;

    use TResponse;

    public function __construct(CrmTipoRevendaService $CrmTipoRevendaService)
    {
        $this->CrmTipoRevendaService = $CrmTipoRevendaService;
    }

    public function getTypeOfResale()
    {
        try {
            $data = $this->CrmTipoRevendaService->getTypeOfResaleService();
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function getDataCommissions(Request $request)
    {
        try {
            $data = $this->CrmTipoRevendaService->getDataCommissionsService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function getPriceList()
    {
        try {
            $data = $this->CrmTipoRevendaService->getPriceListService();
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function getPaymentTerm()
    {
        try {
            $data = $this->CrmTipoRevendaService->getPaymentTermService();
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function getServiceList()
    {
        try {
            $data = $this->CrmTipoRevendaService->getServiceListService();
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function saveNewResaleType(Request $request)
    {
        try {
            $data = $this->CrmTipoRevendaService->saveNewResaleTypeService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function updateResaleType(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->CrmTipoRevendaService->updateResaleTypeService($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function deleteResaleType(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->CrmTipoRevendaService->deleteResaleTypeService($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}
