<?php

namespace CRM\Service;

use CRM\Factory\CrmModoDeDivulgacaoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmModoDeDivulgacaoService {

    protected $CrmModoDeDivulgacaoFactory;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $environment, NewCode $newCode, EntityManager $entityManager, CrmModoDeDivulgacaoFactory $CrmModoDeDivulgacaoFactory)
    {
        $this->CrmModoDeDivulgacaoFactory   = $CrmModoDeDivulgacaoFactory;
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getDisclosureModeService () {
        return $this->CrmModoDeDivulgacaoFactory->getDisclosureModeFactory();
    }

    public function saveNewDisclosureModeService ($row) {
       
        $this->connection->beginTransaction();
        $nrorg = $this->environment->getNrOrg();
        $cdoperador = $this->environment->getCdOperador();

        try {
            foreach ($row["DRG"] as $rows) {

                if ($rows["CDMODODIVULG"] == 0) {

                    $rows["CDMODODIVULG"] = $this->newCode->getCodeByTableName("CDMODODIVULG", $nrorg, 1, 5, false);
                    
                    $params = array(
                        "CDMODODIVULG"   => $rows["CDMODODIVULG"],
                        "NMMODODIVULG"   => $rows["NMMODODIVULG"],
                        "IDATIVO"        => $rows["IDATIVO"],
                        "NRORG"          => $nrorg,
                        "NRORGINCLUSAO"  => $nrorg,
                        "NRORGULTATU"    => $nrorg,
                        "CDOPERINCLUSAO" => $cdoperador,
                        "CDOPERULTATU"   => $cdoperador
                    );
                    
                    $this->CrmModoDeDivulgacaoFactory->insertNewDisclosureModeFactory($params);

                } else {

                    $params = array(
                        "CDMODODIVULG"   => $rows["CDMODODIVULG"],
                        "NMMODODIVULG"   => $rows["NMMODODIVULG"],
                        "IDATIVO"        => $rows["IDATIVO"],
                        "NRORG"          => $nrorg,
                        "NRORGINCLUSAO"  => $nrorg,
                        "NRORGULTATU"    => $nrorg,
                        "CDOPERINCLUSAO" => $cdoperador,
                        "CDOPERULTATU"   => $cdoperador
                    );
                   
                    $this->CrmModoDeDivulgacaoFactory->updateDisclosureModeServiceFactory($params);
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
    public function deleteDisclosureModeService ($row) {
        
        $this->connection->beginTransaction();
        try {
            foreach ($row["CDGS"] as $key => $rows) {

                $relationships = $this->findRelationship($rows);
               
              if ($relationships[0]["CDMODODIVULG"] == 0 ) {
                  
                $params = array(
                  "CDMODODIVULG" => $rows,
              );

                $this->CrmModoDeDivulgacaoFactory->deleteDisclosureModeServiceFactory($params);
                
            } else {
                throw new \Exception("Esse Modo de Divulgação Não Pode Ser Excluido, Pois Já Está Sendo Utilizado!");
            }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function findRelationship ($rows) {
        $params = array(
            "CDMODODIVULG" => $rows,
        );
        return $this->CrmModoDeDivulgacaoFactory->findRelationshipFactory($params);
    }
}