/* Trigger: INSERE_ESTRUTURA_FILIOPER
   Tabela : FILIOPER

   Criao:
   10/02/2014 - Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE TRIGGER INSERE_ESTRUTURA_FILIOPER
AFTER INSERT OR DELETE
ON FILIOPER FOR EACH ROW
DECLARE
   V_NOVOCODIGO        VARCHAR2(20);
   V_NRORGANIZACAOOPER NUMBER;
   V_NRESTRUTURAOPER   NUMBER;
   V_NRESTRUTURAM      NUMBER;
BEGIN
   IF DELETING THEN
      V_NRORGANIZACAOOPER := NULL;
      SELECT MAX(NRORGANIZACAOOPER)
         INTO V_NRORGANIZACAOOPER
      FROM ORGANIZACAOOPER
      WHERE NRORGREL = :OLD.NRORG
        AND CDOPERADOR = :OLD.CDOPERADOR;

      IF V_NRORGANIZACAOOPER IS NOT NULL THEN
         FOR C_FILIAL IN
            (SELECT :OLD.CDFILIAL CDFILIAL, ESTRUTURAM.NRESTRUTURAM
	     FROM ESTRUTURAM
	     WHERE ESTRUTURAM.CDINTESTRUTURA = :OLD.CDFILIAL
	       AND ESTRUTURAM.NRTIPOESTRUTURA = 2
	 ) LOOP
	    DELETE ESTRUTURAOPER
	    WHERE NRORGANIZACAOOPER = V_NRORGANIZACAOOPER
	      AND NRESTRUTURAMREL   = C_FILIAL.NRESTRUTURAM;
	 END LOOP;
      END IF;
   ELSE
      V_NRORGANIZACAOOPER := NULL;
      SELECT MAX(NRORGANIZACAOOPER)
        INTO V_NRORGANIZACAOOPER
      FROM ORGANIZACAOOPER
      WHERE NRORGREL = :NEW.NRORG
        AND CDOPERADOR = :NEW.CDOPERADOR;

      IF V_NRORGANIZACAOOPER IS NULL THEN
         NOVO_CODIGO_SC('ORGANIZACAOOPER', V_NOVOCODIGO);
         V_NRORGANIZACAOOPER := TO_NUMBER(V_NOVOCODIGO);

         INSERT INTO ORGANIZACAOOPER (NRORGANIZACAOOPER, NRORGREL, CDOPERADOR, DTINCLUSAO)
	 VALUES(V_NRORGANIZACAOOPER, :NEW.NRORG, :NEW.CDOPERADOR, SYSDATE);
      END IF;

      IF V_NRORGANIZACAOOPER IS NOT NULL THEN
         FOR C_FILIAL IN
	    (SELECT :NEW.CDFILIAL CDFILIAL, ESTRUTURAM.NRESTRUTURAM
	     FROM ESTRUTURAM
	     WHERE ESTRUTURAM.CDINTESTRUTURA = :NEW.CDFILIAL
	       AND ESTRUTURAM.NRTIPOESTRUTURA = 2
	     ORDER BY 1
	 ) LOOP
	    NOVO_CODIGO_SC('ESTRUTURAOPER', V_NOVOCODIGO);
	    V_NRESTRUTURAOPER := TO_NUMBER(V_NOVOCODIGO);

	    INSERT INTO ESTRUTURAOPER (NRESTRUTURAOPER, NRORGANIZACAOOPER, NRESTRUTURAMREL, DTINCLUSAO)
	    SELECT V_NRESTRUTURAOPER, V_NRORGANIZACAOOPER, C_FILIAL.NRESTRUTURAM, SYSDATE
	    FROM DUAL
	    WHERE NOT EXISTS(SELECT 1
			     FROM ESTRUTURAOPER E
			     WHERE E.NRORGANIZACAOOPER = V_NRORGANIZACAOOPER
                               AND E.NRESTRUTURAMREL   = C_FILIAL.NRESTRUTURAM);

            UPDATE OPERADOR
            SET NRORGTRAB = :NEW.NRORG,
                NRESTRUTTRAB = C_FILIAL.NRESTRUTURAM
            WHERE NRORG = :NEW.NRORG
              AND CDOPERADOR = :NEW.CDOPERADOR
              AND NRESTRUTTRAB IS NULL;

	 END LOOP;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('INSERE_ESTRUTURA_FILIOPER','5.70.000'); END;
/
