IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'FORNECEDOR_DO_LOTE' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION FORNECEDOR_DO_LOTE
GO
CREATE FUNCTION FORNECEDOR_DO_LOTE(
   @P_CDFILIAL     VARCHAR(04),
   @P_NRLOTEESTQ   VARCHAR(20),
   @P_NRSUBLOTE    VARCHAR(04),
   @P_CDPRODUTO    VARCHAR(10)) RETURNS VARCHAR
AS
BEGIN

   DECLARE @V_CDFORNECED   VARCHAR(21);
   DECLARE @V_NRINSJURFORN VARCHAR(20);
   DECLARE @V_NMRAZSOCFORN VARCHAR(100);
   DECLARE @V_RETURN VARCHAR(143);

   SELECT @V_CDFORNECED = MAX(N.CDFORNECED), @V_NRINSJURFORN = MAX(F.NRINSJURFORN), @V_NMRAZSOCFORN = MAX(F.NMRAZSOCFORN)
     FROM LOTE L, ITLANCTOEST I, LANCTOESTOQ A, NOTAFISCAL N, FORNECEDOR F
    WHERE L.CDFILIAL = @P_CDFILIAL
      AND L.NRLOTEESTQ = @P_NRLOTEESTQ
      AND L.NRSUBLOTE = @P_NRSUBLOTE
      AND L.CDPRODUTO = @P_CDPRODUTO
      AND L.CDFILIAL = I.CDFILIAL
      AND L.NRLOTEESTQ = I.NRLOTEESTQ
      AND L.NRSUBLOTE = I.NRSUBLOTE
      AND L.CDPRODUTO = I.CDPRODUTO
      AND I.CDFILIAL = A.CDFILIAL
      AND I.NRLANCESTQ = A.NRLANCESTQ
      AND A.IDTPLANCTO IN ('E','2')
      AND A.CDFILIAL = N.CDFILIAL
      AND A.NRLANCTONF = N.NRLANCTONF
      AND N.CDFORNECED = F.CDFORNECED;

   SET @V_RETURN = @V_CDFORNECED+''+@V_NRINSJURFORN+''+@V_NMRAZSOCFORN;
   RETURN(@V_RETURN);
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'FORNECEDOR_DO_LOTE','6.19.XXX';
GO
